import 'package:dcoupon_sdk_flutter_package/src/localizations_strings.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';

class LegalDocChangesWidget extends StatelessWidget {
  final String version;
  final String changes;

  const LegalDocChangesWidget({
    Key? key,
    required this.version,
    required this.changes,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.symmetric(horizontal: 16.0),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
          Text(
            Strings.of(context).common_label_version + ' ${version}',
            style: TextStyle(
              fontWeight: FontWeight.bold,
            ),
          ),
          Html(
            data: changes,
            style: {
              "a": Style(
                color: Colors.blue,
                textDecorationColor: Colors.blueAccent,
                textDecoration: TextDecoration.underline,
              ),
            },
          ),
          SizedBox(height: 8.0),
        ],
      ),
    );
  }
}
