
import 'package:flutter/material.dart';
import 'package:dcoupon_sdk_flutter_package/src/presentation/widgets/platform_progress_indicator.dart';

import 'package:dcoupon_sdk_flutter_package/src/presentation/widgets/webview/webview_widget_mobile.dart'
    if (dart.library.html) 'package:dcoupon_sdk_flutter_package/src/presentation/widgets/webview/webview_widget_web.dart'
    as webview_widget;

const IFRAME_ID = 'iframe';

class WebviewDialogWidget extends StatefulWidget {
  final String? url;

  WebviewDialogWidget({
    Key? key,
    required this.url,
  }) : super(key: key);

  @override
  State<WebviewDialogWidget> createState() => _WebviewDialogWidgetState();
}

class _WebviewDialogWidgetState extends State<WebviewDialogWidget> {
  bool _isLoadingPage = true;

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.only(
        top: 48.0,
        left: 8.0,
        bottom: 48.0,
      ),
      child: widget.url == null
          ? Container()
          : NotificationListener<OverscrollIndicatorNotification>(
              onNotification: (OverscrollIndicatorNotification overscroll) {
                overscroll.disallowIndicator();
                return false;
              },
              child: Container(
                padding: EdgeInsets.only(
                  top: 18.0,
                  bottom: 18.0,
                ),
                decoration: BoxDecoration(
                  color: Colors.white,
                  borderRadius: BorderRadius.circular(10.0),
                ),
                child: Stack(
                  children: [
                    webview_widget.WebviewWidget(
                      initialUrl: widget.url!,
                      onLoadFinished: () {
                        setState(() {
                          _isLoadingPage = false;
                        });
                      },
                    ),
                    _isLoadingPage
                        ? Container(
                            color: Theme.of(context).scaffoldBackgroundColor,
                            child: Center(
                              child: PlatformProgressIndicator(),
                            ),
                          )
                        : Container(),
                  ],
                ),
              ),
            ),
    );
  }
}
