import 'dart:async';

import 'package:dcoupon_sdk_flutter_package/src/core/device_info.dart';
import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';

class WebviewWidget extends StatefulWidget {
  final String initialUrl;
  final VoidCallback onLoadFinished;

  const WebviewWidget({
    Key? key,
    required this.initialUrl,
    required this.onLoadFinished,
  }) : super(key: key);

  @override
  State<WebviewWidget> createState() => _WebviewWidgetState();
}

class _WebviewWidgetState extends State<WebviewWidget> {
  final Completer<WebViewController> _controller =
      Completer<WebViewController>();

  @override
  void initState() {
    if (DevicePlatform.isAndroid) WebView.platform = SurfaceAndroidWebView();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return WebView(
      onWebViewCreated: (WebViewController webViewController) {
        _controller.complete(webViewController);
      },
      initialUrl: widget.initialUrl,
      javascriptMode: JavascriptMode.unrestricted,
      onPageFinished: (url) {
        widget.onLoadFinished();
      },
    );
  }
}
