// ignore_for_file: avoid_web_libraries_in_flutter

import 'package:dcoupon_sdk_flutter_package/src/presentation/widgets/webview/webview_dialog_widget.dart';
import 'package:flutter/material.dart';
import 'dart:html' as html;
import 'dart:ui' as ui;

class WebviewWidget extends StatefulWidget {
  final String initialUrl;
  final VoidCallback onLoadFinished;

  const WebviewWidget({
    Key? key,
    required this.initialUrl,
    required this.onLoadFinished,
  }) : super(key: key);

  @override
  State<WebviewWidget> createState() => _WebviewWidgetState();
}

class _WebviewWidgetState extends State<WebviewWidget> {

  void setupIframe(String url) {
    // ignore: undefined_class, undefined_function
    html.IFrameElement iframeElement = html.IFrameElement()
      ..src = url
      ..style.border = 'none';
    // ..onLoad.listen((event) {
    //   // perform you logic here.
    // });

    // ignore: undefined_prefixed_name
    ui.platformViewRegistry.registerViewFactory(
      IFRAME_ID,
      (int viewId) => iframeElement,
    );
  }

  @override
  Widget build(BuildContext context) {
    setupIframe(widget.initialUrl);

    return Directionality(
      textDirection: TextDirection.ltr,
      child: Center(
        child: SizedBox(
          width: double.infinity,
          height: double.infinity,
          child: HtmlElementView(
            // key: uniqueKey,
            viewType: IFRAME_ID,
            onPlatformViewCreated: (id) {
              widget.onLoadFinished();
            },
          ),
        ),
      ),
    );
  }
}
